package com.ztmap.project.common;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import com.ztmap.common.constant.Constants;
import com.ztmap.common.utils.StringUtils;
import com.ztmap.common.utils.file.FileUploadUtils;
import com.ztmap.common.utils.file.FileUtils;
import com.ztmap.framework.config.ZTMapConfig;
import com.ztmap.framework.config.ServerConfig;
import com.ztmap.framework.web.domain.AjaxResult;

import java.io.File;
import java.net.URLDecoder;

/**
 * 通用请求处理
 * 
 * @author ztmap
 */
@Controller
public class CommonController
{
    private static final Logger log = LoggerFactory.getLogger(CommonController.class);

    @Autowired
    private ServerConfig serverConfig;

    /**
     * 通用下载请求
     * 
     * @param fileName 文件名称
     * @param delete 是否删除
     */
    @GetMapping("common/download")
    public void fileDownload(String fileName, Boolean delete, HttpServletResponse response, HttpServletRequest request)
    {
        try
        {
            if (!FileUtils.checkAllowDownload(fileName))
            {
                throw new Exception(StringUtils.format("文件名称({})非法，不允许下载。 ", fileName));
            }
            String realFileName = System.currentTimeMillis() + fileName.substring(fileName.indexOf("_") + 1);
            String filePath = ZTMapConfig.getDownloadPath() + fileName;

            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtils.setAttachmentResponseHeader(response, realFileName);
            FileUtils.writeBytes(filePath, response.getOutputStream());
            if (delete)
            {
                FileUtils.deleteFile(filePath);
            }
        }
        catch (Exception e)
        {
            log.error("下载文件失败", e);
        }
    }

    /**
     * 数据访问
     * @param response
     * @param request
     */
    @GetMapping("/data/**")
    @ResponseBody
    public void data(HttpServletResponse response, HttpServletRequest request)
    {
        try
        {
            String url = request.getRequestURI();
            String realFileName = url.substring(url.indexOf("data/")+4);//System.currentTimeMillis() + fileName.substring(fileName.indexOf("_") + 1);
            String re = realFileName.substring(realFileName.indexOf("profile/")+7);//System.currentTimeMillis() + fileName.substring(fileName.indexOf("_") + 1);
            re = URLDecoder.decode(re,"utf-8");
            String filePath = ZTMapConfig.getProfile()+re;
            //log.info("filePath="+filePath);
            if(!new File(filePath).exists()){
                throw new Exception();
            }

            if(url.endsWith(".json")){
                response.setContentType(MediaType.APPLICATION_JSON_VALUE);
            }else {
                response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            }
            FileUtils.setAttachmentResponseHeader(response, re);
            FileUtils.writeBytes(filePath, response.getOutputStream());
        }
        catch (Exception e)
        {
            //e.printStackTrace();
            log.error("访问文件失败", e);
        }
    }

    /**
     * 通用上传请求
     */
    @PostMapping("/common/upload")
    @ResponseBody
    public AjaxResult uploadFile(MultipartFile file) throws Exception
    {
        try
        {
            // 上传文件路径
            String filePath = ZTMapConfig.getUploadPath();
            // 上传并返回新文件名称
            String fileName = FileUploadUtils.upload(filePath, file);
            String url = serverConfig.getUrl() + fileName;
            AjaxResult ajax = AjaxResult.success();
            ajax.put("fileName", fileName);
            ajax.put("url", url);
            return ajax;
        }
        catch (Exception e)
        {
            return AjaxResult.error(e.getMessage());
        }
    }

    /**
     * 本地资源通用下载
     */
    @GetMapping("/common/download/resource")
    public void resourceDownload(String resource, HttpServletRequest request, HttpServletResponse response)
            throws Exception
    {
        try
        {
            if (!FileUtils.checkAllowDownload(resource))
            {
                throw new Exception(StringUtils.format("资源文件({})非法，不允许下载。 ", resource));
            }
            // 本地资源路径
            String localPath = ZTMapConfig.getProfile();
            // 数据库资源地址
            String downloadPath = localPath + StringUtils.substringAfter(resource, Constants.RESOURCE_PREFIX);
            // 下载名称
            String downloadName = StringUtils.substringAfterLast(downloadPath, "/");
            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtils.setAttachmentResponseHeader(response, downloadName);
            FileUtils.writeBytes(downloadPath, response.getOutputStream());
        }
        catch (Exception e)
        {
            log.error("下载文件失败", e);
        }
    }
}
